'use strict';

var ejs = require('ejs');
var loaderUtils = require('loader-utils');
var path = require('path')
var vm = require('vm')

module.exports = function (source) {

    if (this.cacheable) {
        this.cacheable();
    }
    if (/\.js$/.test(this.resourcePath)) {
        return source;
    }

    var __include = function (include,filePath,data) {
        var defaultComponentData = {
            __context:path.posix.parse(filePath).dir
        }
        data||(data={})
        return include(filePath,Object.assign(data,defaultComponentData))
    }

    var defaultOptions = {
        root:this.context,
        filename:path.posix.parse(this.resourcePath).base
    }
    var defaultData = {
        __dirname:this.context,
        __path:path,
        __include:__include
    }

    var options = Object.assign(defaultOptions,this.query)
    var data = Object.assign(defaultData,this.query.data)

    var html = ejs.render(source,data,options);

    console.log(html)

    return html
};
